(************************************************************
Author: Deepak Shenoy
        shenoy@agnisoft.com
Copyright (C) 2000 Agni Software Pvt. Ltd.
All Rights Reserved.
http://www.agnisoft.com

This form demonstrates:
1. Searching an LDAP provider using ADO and SQL. You must have Windows
2000 installed and Active Directory enabled for this to work.
2. Searching an Internet based ADSI provider (you need a connection to the
internet to see this working)
3. Getting schema properties of ADSI objects
4. Searching using IDirectorySearch.

********************************************************)
unit mainform;

interface      

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, ADODB, StdCtrls, ComCtrls, comobj, adsHlp, activeds_tlb,
  activex, variants;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    DataSource1: TDataSource;
    ADOQuery1: TADOQuery;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    DBGrid1: TDBGrid;
    TabSheet2: TTabSheet;
    DataSource2: TDataSource;
    ADODataSet1: TADODataSet;
    ISrchBtn: TButton;
    lvResult: TListView;
    TabSheet3: TTabSheet;
    lstMand: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    lstOptional: TListBox;
    edtObjectPath: TEdit;
    Label3: TLabel;
    Button3: TButton;
    Button1: TButton;
    TabSheet4: TTabSheet;
    Label4: TLabel;
    edtDSPath: TEdit;
    lbDSSearch: TListBox;
    Button2: TButton;
    Label5: TLabel;
    ADOConnection2: TADOConnection;
    procedure ISrchBtnClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}

procedure TForm1.ISrchBtnClick(Sender: TObject);
var temp, Rs,conn, com : Variant;
    newLine : TListItem;
    s : string;
    i, j : integer;
begin
  conn := CreateOleObject('ADODB.Connection');
  com := CreateOleObject('ADODB.Command');
  try
    conn.Provider := 'ADsDSOObject';
    conn.open;
    com.ActiveConnection := conn;
    Com.CommandText :='<GC://ldap.whowhere.com:389>;(|(|(cn=shenoy*))(sn=shenoy*));cn,mail;subtree';
    Com.Properties['Timeout'] := 600;
    Com.Properties['Cache Results'] := False;
    Com.Properties['Size Limit'] := 200;
    Rs := COm.Execute;
    lvResult.Items.Clear;
    While Not rs.EOF do
    begin
      newLine := lvResult.Items.Add;
      //(, , rs.Fields(0).Value(0))

      For i := 1 To rs.Fields.Count - 1 do
      begin
        If (VarIsArray(rs.Fields[i].Value)) And Not (VarIsNull(rs.Fields[i].Value)) Then
        begin
          s := '';
          temp := rs.Fields[i].value;
          For j := VarArrayLowBound(temp, 1) To VarArrayHighBound(temp, 1) do
          begin
            If (s <> '') Then
              s := s + ', ';

            s := s + temp[j];
          end;
          newLine.SubItems.Add(s);
        end
        Else
          If (Not (VarIsNull(rs.Fields[i].Value))) Then
            newLine.SubItems.Add(rs.Fields[i].Value);
      end;
      rs.MoveNext;
    end;

    Rs := NULL;
  finally
    com := NULL;
    conn.Close;
    conn := NULL;
  end;
end;


procedure TForm1.Button4Click(Sender: TObject);
var obj : IAds;
    search : IDirectorySearch;
    tst : PWideChar;
    p : array[0..0] of PWideChar;
    cls : IADsClass;
    cont : IADsContainer;
    i : integer;
    ptrResult : THandle;
    col : ads_search_column ;
    hr : HResult;
    opt : array[0..0] of ads_searchpref_info; // has to be an array
    dwErr : DWord;
    szErr : array[0..255] of WideCHar;
    szName : array[0..255] of WideChar;
begin
   lbDsSearch.Items.CLear;
   AdsGetObject(edtDSPath.Text, IDirectorySearch, search);
   try
     p[0] := StringToOleStr('Name');
     opt[0].dwSearchPref := ADS_SEARCHPREF_SEARCH_SCOPE;
     opt[0].vValue.dwType := ADSTYPE_INTEGER;
     opt[0].vValue.Integer := ADS_SCOPE_SUBTREE;
     hr := search.SetSearchPreference(@opt[0],1);
     if (hr <> 0) then
       begin
         hr := ADsGetLastError(dwErr, @szErr[0], 254, @szName[0], 254);
         ShowMessage(WideCharToString(szErr));
         Exit;
       end;
     hr := search.ExecuteSearch('(objectCategory=Group)',@p[0], 1, ptrResult);
     hr := search.GetNextRow(ptrResult);
     while (hr <> S_ADS_NOMORE_ROWS) do
     begin
        hr := search.GetColumn(ptrResult, p[0],col);
        if Succeeded(hr) then
        begin
          if col.pADsValues <> nil then
            lbDsSearch.Items.Add(col.pAdsvalues^.CaseIgnoreString);
          search.FreeColumn(col);
        end;
        Hr := search.GetNextRow(ptrResult);
     end;
   finally
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   // gets the
   ADOQuery1.Active := FALSE;
   ADOQuery1.Active := True;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  case PageControl1.ActivePageIndex of
  0 : begin
        Button1.Enabled := TRUE;
        ISrchbtn.Enabled := FALSE;
      end;
  1 : begin
        Button1.Enabled := FALSE;
        ISrchbtn.Enabled := TRUE;
      end;
  else begin
        Button1.Enabled := FALSE;
        ISrchbtn.Enabled := FALSE;
      end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var obj : IAds;
    s : WideString;
    cls : IADsClass;
    cont : IADsContainer;
    i : integer;
begin
   AdsGetObject(edtObjectPath.Text, IADs, obj );
   s := obj.Get_Schema;
   AdsGetObject(s, IADsClass,  cls );
   if VarIsArray(cls.MandatoryProperties) then
   begin
    for i := VarArrayLowBound(cls.MandatoryProperties,1) to VarArrayHighBound(cls.MandatoryProperties,1) do
    begin
          s := cls.MandatoryProperties[i];
          lstMand.Items.Add(s);
    end;
   end;
   if VarIsArray(cls.OptionalProperties) then
   begin
    for i := VarArrayLowBound(cls.OptionalProperties,1) to VarArrayHighBound(cls.OptionalProperties,1) do
    begin
          s := cls.OptionalProperties[i];
          lstOptional.Items.Add(s);
    end;
   end;
end;

end.

