(************************************************************
Author: Deepak Shenoy
        shenoy@agnisoft.com
Copyright (C) 2000 Agni Software Pvt. Ltd.
All Rights Reserved.
http://www.agnisoft.com

Description:
A generalized object for a BDE Alias. Note: No schema implemented
so no properties are present. To Add them, you'd need to implement
the Get and Put procedures. You will also need to implement a
class for the schema (derived from IADsClass) and the properties
(from IADsProperty). You needn't implement syntax objects if you will only
use standard data types.
********************************************************)
unit GenObject;

interface

uses
  ComObj, ActiveX, BDEProv_TLB, StdVcl, AdsCore, ActiveDs_Tlb;

type
  TBDEGenObject = class(TAdsAutoObject, IBDEGenObject, IADs)
  private
    procedure SetAlias(const Value: string);
  protected
    FFilter, FHints : OleVariant;
    function Get(const bstrName: WideString): OleVariant; safecall;
    function Get_ADsPath: WideString; safecall;
    function Get_Class_: WideString; safecall;
    function Get_GUID: WideString; safecall;
    function Get_Name: WideString; safecall;
    function Get_Parent: WideString; safecall;
    function Get_Schema: WideString; safecall;
    function GetEx(const bstrName: WideString): OleVariant; safecall;
    procedure GetInfo; safecall;
    procedure GetInfoEx(vProperties: OleVariant; lnReserved: Integer);
      safecall;
    procedure Put(const bstrName: WideString; vProp: OleVariant); safecall;
    procedure PutEx(lnControlCode: Integer; const bstrName: WideString;
      vProp: OleVariant); safecall;
    procedure SetInfo; safecall;
    { Protected declarations }

    procedure Initialize; override;
  public
    FAlias : string;
    property Alias : string read FAlias write SetAlias;
  end;

implementation

uses ComServ;

function TBDEGenObject.Get(const bstrName: WideString): OleVariant;
begin
  Result := Inherited Get(bstrName);
end;

function TBDEGenObject.Get_ADsPath: WideString;
begin
  Result := 'BDE://' + FAlias;
end;

function TBDEGenObject.Get_Class_: WideString;
begin
  Result := inherited Get_Class_;
end;

function TBDEGenObject.Get_GUID: WideString;
begin
  Result := GUIDToString( IBDEGenObject );
end;

function TBDEGenObject.Get_Name: WideString;
begin
  REsult := _Name;
end;

function TBDEGenObject.Get_Parent: WideString;
begin
  Result := _Parent;
end;

function TBDEGenObject.Get_Schema: WideString;
begin
  NotImpl;
end;

function TBDEGenObject.GetEx(const bstrName: WideString): OleVariant;
begin
  NotImpl;
end;

procedure TBDEGenObject.GetInfo;
begin
  NotImpl;
end;

procedure TBDEGenObject.GetInfoEx(vProperties: OleVariant;
  lnReserved: Integer);
begin
  NotImpl;
end;

procedure TBDEGenObject.Put(const bstrName: WideString; vProp: OleVariant);
begin
  NotImpl;
end;

procedure TBDEGenObject.PutEx(lnControlCode: Integer;
  const bstrName: WideString; vProp: OleVariant);
begin
  NotImpl;
end;

procedure TBDEGenObject.SetInfo;
begin
  NotImpl;
end;

procedure TBDEGenObject.Initialize;
begin
  inherited;
  _Parent := 'BDE:';
  _Name := 'BDE://' ;
end;

procedure TBDEGenObject.SetAlias(const Value: string);
begin
  FAlias := Value;
  _Name := FAlias;
end;

initialization
  TAutoObjectFactory.Create(ComServer, TBDEGenObject, Class_BDEGenObject,
    ciMultiInstance, tmApartment);
end.
